# MumbleServer::ServerContextCallback

## Overview

### interface ServerContextCallback

Callback interface for context actions. You need to supply one of these for `Server::addContext`. If an added callback ever throws an exception or goes away, it will be automatically removed. Please note that all callbacks are done asynchronously; murmur does not wait for the callback to complete before continuing processing.

## Operation Index

contextAction
  Called when a context action is performed.

## Operations

### void contextAction(string action, User usr, int session, int channelid)

Called when a context action is performed.

#### Parameters

action
  Action to be performed.
usr
  User which initiated the action.
session
  If nonzero, session of target user.
channelid
  If not -1, id of target channel.